/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.math;

import java.util.ArrayList;
import java.util.List;

import org.junit.Assert;
import org.junit.Test;

import de.hft.stuttgart.citydoctor2.datastructure.Vertex;

/**
 * 
 * @author Matthias Betz
 *
 */
public class OrthogonalRegressionLineTest {

	@Test
	public void testRegressionLine() {
		Vertex v1 = new Vertex(0, 0, 0);
		Vertex v2 = new Vertex(1, 1, 0);
		Vertex v3 = new Vertex(2, 2, 0);
		Vertex v4 = new Vertex(5, 5, 0);
		
		List<Vertex> vertices = new ArrayList<>();
		vertices.add(v1);
		vertices.add(v2);
		vertices.add(v3);
		vertices.add(v4);
		
		Line3d result = OrthogonalRegressionLine.getRegressionLine(vertices);
		Assert.assertEquals(0, result.distanceToPoint(v2), 0.000001);
		Assert.assertEquals(Math.sqrt(2) / 2, result.distanceToPoint(new Vertex(1, 0, 0)), 0.000001);
	}

}
